# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .company_type_enum import CompanyTypeEnum
from .user_tier_enum import UserTierEnum


class Company(pydantic.BaseModel):
    id: int
    primary_contact_information: str
    billing_contact_information: str
    employee_count: int
    extended_properties: typing.Optional[typing.Dict[str, typing.Any]]
    modified: str
    created: str
    code: str
    type: typing.Optional[CompanyTypeEnum]
    name: str
    description: typing.Optional[str]
    is_active: typing.Optional[bool]
    phone_1: typing.Optional[str] = pydantic.Field(alias="phone1")
    phone_2: typing.Optional[str] = pydantic.Field(alias="phone2")
    post_code: typing.Optional[str]
    address_1: typing.Optional[str] = pydantic.Field(alias="address1")
    address_2: typing.Optional[str] = pydantic.Field(alias="address2")
    country: typing.Optional[str]
    region: typing.Optional[str]
    city: typing.Optional[str]
    company_color: typing.Optional[str]
    logo: typing.Optional[str]
    show_coded_labor_material_only: typing.Optional[bool]
    email: typing.Optional[str]
    default_user_tier: typing.Optional[UserTierEnum]
    system_admin_email: typing.Optional[str]
    primary_contact: typing.Optional[int]
    billing_contact: typing.Optional[int]
    permission_group: typing.Optional[int]
    admin_permission_group: typing.Optional[int]
    read_permission: typing.Optional[int]
    admin_permission: typing.Optional[int]
    denied_permission: typing.Optional[int]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
